#include <matplot/matplot.h>
#include <Eigen/Core>
#include "misc.hpp"

using namespace matplot;

typedef std::vector<double> data;
typedef std::vector<data> container1;
typedef std::pair<std::vector<data>, std::vector<data>> container2;
typedef std::vector<std::pair<std::vector<data>, std::vector<data>>> container3;

container2 packData(data& data_x_, data& data_y_, data& data_psi_, data& data_x, data& data_y);

container2 packData(data& data_psi_ref, data& data_psi_d, data& data_psi, data& data_u_ref, data& data_u_d, data& data_u);

std::pair<data,data> get_shape(double scale, double x0, double y0, double psi);

void plotXY(container3& ship_data, int scenario);

void plotDynamics(data& time, container3& ship_data, int scenario, bool limit_time);

void plotDistance(data& time, container1& dist, std::vector<std::string> ASV_ASV, int scenario, int n_ASV, bool limit_time);

void drawEllipse(Eigen::Vector2d position, double a, double b, double angle);

void plotXY(container3& ship_data, std::vector<Ellipse> map_details, std::vector<std::vector<Eigen::Vector2d>> waypoints);