#include "../include/COLREGs.hpp"

int main()
{
    int idx = 0;
    bool safe = true;
    std::vector<std::pair<PoseSE2,Eigen::Vector3d>> data;
    std::pair<PoseSE2,Eigen::Vector3d>
    ship1 = std::make_pair(PoseSE2(0,0, 0), Eigen::Vector3d(2,0,0)),
    ship2 = std::make_pair(PoseSE2(10,-10, M_PI/3), Eigen::Vector3d(2,0,0)),
    // ship3 = std::make_pair(PoseSE2(50,-1,0), Eigen::Vector3d(1,0,0));
    ship3 = std::make_pair(PoseSE2(15,-15,M_PI/2), Eigen::Vector3d(1,0,0));
    data.push_back(ship1);
    data.push_back(ship2);
    data.push_back(ship3);

    COLREGs colregs(data,idx);
    colregs.updateState(safe);
    colregs.updateEncounterType();
    auto [SO, dir] = colregs.getAction();
    std::cout << "safe? " << safe << std::endl;
    std::cout << "Stand On? " << SO << std::endl;
    if (dir == RotType::none)
        std::cout << "none" << std::endl;
    else if (dir == RotType::right)
        std::cout << "right" << std::endl;

    for (int i=0; i < colregs.encounter_types.size(); ++i)
    {
        std::cout << colregs.encounter_types[i] << std::endl;
    }
}